#include "libdup.h"
char *repeat (const char *word, size_t n, const char ** const error_return) {
// return must be free(d)
    char *s, *t;
    int i, len = strlen (word);
    *error_return = NULL;
    if (!word) *error_return = "Empty String!";
    if (len > MAX_STRING) *error_return = "String too large!";
    if (n > MAX_REPEAT || n < 1) *error_return = "Out of range!";
    if (*error_return) return NULL;
    if ((s = malloc(n * len + 1))) {
        for (i=0, t=s; i<n; i++) {
            t = len + strncpy (t, word, len);
        }
        *t='\0';
        return s;
    }
    else *error_return = "Out of Memory!";
    return NULL;
}
